       program colorize_movie
       implicit none
      CHARACTER :: RPREFIX*6, RSUFFIX*4,RFILENAME*25,WFILENAME*25
      CHARACTER :: RNUM1*1, RNUM2*1
      INTEGER(2) ::  IFILE1,IFILE2
      character*1, allocatable, dimension(:,:) :: elevations,shadevals
       character*30 spectrum_file,topfile,elevfile
       character*80 garbage
       integer rcolors(256),gcolors(256),bcolors(256)
       integer rrrr,gggg,bbbb,ierror,iteration
       integer rcol,gcol,bcol
       integer lrval,lgval,lbval,hrval,hgval,hbval
       integer rvalue,gvalue,bvalue
       byte bval
       character*1 achar
       real*8 maximum_elevation,minimum_elevation,afactor,bfactor
       real*8 localelev,mininputelev,maxinputelev
       real*8 lowfraction,highfraction
       real*8 rslope,rintercept,gslope,gintercept,bslope,bintercept
       real*8 scaleratio,scalevalue,realelevation
       real*8 minrealelevation,maxrealelevation
       integer i,ilow,ihigh,k,j,l,m
       integer number_of_files
       integer mx,my,iterno,mxx,myy
       real*8 lowelevations(200),highelevations(200)
       real*8 averagelowelevation,averagehighelevation
       real*8 lowlimit,highlimit,lowcutoff,highcutoff
      IFILE1=48
      IFILE2=48
       open(10,name='colorize_movie.prm')
       read(10,100) RPREFIX
       read(10,100) spectrum_file
       read(10,*) number_of_files
       read(10,*) lowlimit,highlimit
       rcolors=0
       gcolors=0
       bcolors=0
       open(15,name=spectrum_file)
       read(15,100) garbage
100    format(a)       
       read(15,*) lowfraction, lrval, lgval,lbval
       write(*,250) lowfraction, lrval, lgval, lbval
250    format(' fraction=',g12.5,' r=',i5,' g=',i5,' b=',i5)       
       if (lowfraction.ne.0.0) then
          write(*,200)
200       format('invalid spectrum file')
          stop

       endif
       ilow=1
       do
         read(15,*,end=600) highfraction,hrval,hgval,hbval
         write(*,250) highfraction,hrval,hgval,hbval
         ihigh=nint(2.56*highfraction)
         rslope=(hrval-lrval)/(ihigh-ilow)
         rintercept=lrval-rslope*ilow
         gslope=(hgval-lgval)/(ihigh-ilow)
         gintercept=lgval-gslope*ilow
         bslope=(hbval-lbval)/(ihigh-ilow)
         bintercept=lbval-bslope*ilow
         do i=ilow,ihigh
            rrrr=int(rslope*i+rintercept)
            if (rrrr.lt.0) rrrr=0
            if (rrrr.gt.255) rrrr=255
            rcol=rrrr
            rcolors(i)=rcol
            gggg=int(gslope*i+gintercept)
            if (gggg.lt.0) gggg=0
            if (gggg.gt.255) gggg=255
            gcol=gggg
            gcolors(i)=gcol
            bbbb=int(bslope*i+bintercept)
            if (bbbb.lt.0) bbbb=0
            if (bbbb.gt.255) bbbb=255
            bcol=bbbb
            bcolors(i)=bcol

         enddo
         lowfraction=highfraction
         lrval=hrval
         lgval=hgval
         lbval=hbval
         ilow=ihigh
         if (highfraction.eq.100.0) exit
       enddo
600    continue
       do i=1,256
          write(*,175) i, rcolors(i),gcolors(i),bcolors(i)
175    format(4i5)
       enddo
       topfile=RPREFIX//'.top'
       averagelowelevation=0.0
       averagehighelevation=0.0
       open(20,name=topfile)
       do i=1,number_of_files
          read(20,*) iteration,mx,my,highelevations(i),lowelevations(i)
          averagehighelevation=averagehighelevation+highelevations(i)
          averagelowelevation=averagelowelevation+lowelevations(i)
       enddo
       mxx=2*mx
       myy=2*my
       write(*,366) mx,my,mxx,myy
366    format('mx=',i5,' my=',i5' mxx=',i5,' myy=',i5 )      
       averagehighelevation=averagehighelevation/number_of_files
       averagelowelevation=averagelowelevation/number_of_files
       lowcutoff=(averagehighelevation-averagelowelevation)*lowlimit+averagelowelevation
       highcutoff=(averagehighelevation-averagelowelevation)*highlimit+averagelowelevation
       write(*,329) averagelowelevation,averagehighelevation,lowcutoff,highcutoff
329    format('avg.  low=',g12.5,' avg. high=',g12.5, ' low cut=',g12.5,' high cut=',g12.5)       
       close(20)
       allocate(elevations(mx,my),shadevals(mxx,myy),stat=ierror)
       elevfile=RPREFIX//'top.raw'
       open(25,name=elevfile,form='binary')
       do k=1,number_of_files
	    RNUM1=CHAR(IFILE1)
       if (ifile2.gt.57)  then
           rnum2=char(ifile2+40)
       else
	        RNUM2=CHAR(IFILE2)
      ENDIF
       RFILENAME=RPREFIX//RNUM2//RNUM1//'.raw'
       WFILENAME=RPREFIX//RNUM2//RNUM1//'_c.raw'
          IFILE1=IFILE1+1
          IF (IFILE1.GT.57) THEN
              IFILE1=48
              IFILE2=IFILE2+1
          ENDIF
       read(25,end=700) elevations
       open(30,file=RFILENAME,form='binary')
       read(30) shadevals
       close(30)
       open(35,file=wfilename)
        mininputelev=1.0e+25
       maxinputelev=-mininputelev      
       do j=1,mx
       do i=1,my
         localelev=float(ichar(elevations(i,j)))
         if (localelev.gt.maxinputelev) maxinputelev=localelev
         if (localelev.lt.mininputelev) mininputelev=localelev
       enddo
       enddo
       afactor=(highelevations(k)-lowelevations(k))/(maxinputelev-mininputelev)
       bfactor=lowelevations(k)-afactor*mininputelev
       write(*,765) afactor,bfactor
765    format('afactor=',g12.5,' bfactor=',g12.5)              
       minrealelevation=1.0e+25
       maxrealelevation=-minrealelevation
       do j=1,myy
        do i=1,mxx
       l=(j-1)/2+1
       m=(i-1)/2+1
         localelev=float(ichar(elevations(m,l)))
 !        if (localelev.gt.maxinputelev) maxinputelev=localelev
 !        if (localelev.lt.mininputelev) mininputelev=localelev
         realelevation=afactor*localelev+bfactor
!         realelevation=(localelev*(highelevations(k)-lowelevations(k))/255.0+lowelevations(k))
         if (realelevation.gt.maxrealelevation) maxrealelevation=realelevation
         if (realelevation.lt.minrealelevation) minrealelevation=realelevation
!         goto 3345
!         write(*,388) realelevation
388      format(3g12.5)         
         scaleratio=255.0/(highcutoff-lowcutoff)
         
         scalevalue=(realelevation-lowcutoff)*scaleratio
         if (scalevalue.lt.0.0) scalevalue=0.0
         if (scalevalue.gt.255.0) scalevalue=255.0
         rvalue=int(float(rcolors(int(scalevalue)+1))*float(ichar(shadevals(i,j)))/255.0)
         gvalue=int(float(gcolors(int(scalevalue)+1))*float(ichar(shadevals(i,j)))/255.0)
         bvalue=int(float(bcolors(int(scalevalue)+1))*float(ichar(shadevals(i,j)))/255.0)
         if (rvalue.lt.0) rvalue=0
         if (rvalue.gt.255) rvalue=255
         if (gvalue.lt.0) gvalue=0
         if (gvalue.gt.255) gvalue=255
         if (bvalue.lt.0) bvalue=0
         if (bvalue.gt.255) bvalue=255
         bval=rvalue
         achar=char(bval)
         write(35,190) achar
190      format(a1,$)
         bval=gvalue
         achar=char(bval)
         write(35,190) achar
         bval=bvalue
         achar=char(bval)
         write(35,190) achar
!3345     continue
       enddo
       enddo
         write(*,543) mininputelev,maxinputelev
543      format('min imput=',g12.5,' max input=',g12.5)          
         scaleratio=255.0/(highcutoff-lowcutoff)
         realelevation=minrealelevation
         scalevalue=(realelevation-lowcutoff)*scaleratio 
         write(*,544) realelevation,scalevalue
         realelevation=maxrealelevation
         scalevalue=(realelevation-lowcutoff)*scaleratio
         write(*,544) realelevation,scalevalue
544      format('elev=',g12.5,' scalevalue=',g12.5)                                            
       close(35)
       enddo
       close(25) 
700       stop
       end
