      module crater_vars
      IMPLICIT NONE
      save
	  integer immx,jmmx
      INTEGER KSIZE,mx,my,ncraters,outputinterval
      INTEGER TOPFILE,SHADEFILE,BASEFILE,inputtype
      INTEGER*4 NIMPACTS,ITERNO,ITOTHITS,DIFFINTERVAL
      INTEGER*4 NOISEINTERVAL
      REAL*8 ALPHA,ALINV,MINDIAM,MAXDIAM,CCON,BCON
      PARAMETER(immx=1024,jmmx=1024)
      INTEGER IMIN,IMAX,JMIN,JMAX,COUNT2,COUNT10
      INTEGER IMINR,IMAXR,JMINR,JMAXR,outputtype
      REAL*8 DIAMETER,XMIN,YMIN,XMAX,YMAX,XCENTER,YCENTER
      REAL*8 H1,H2,M1,M2,RADIUS,MAXRANGE,ELEVBASE,DIAMCUT
      REAL*8 DEPOSITSD,NOISESD,ELEVINHERIT,BETA,dxx
      REAL*8 H1MULT,H1EXP,H2MULT,H2EXP,INITGRAD
      REAL*8 SH1MULT,SH1EXP,SH2MULT,SH2EXP
      REAL*8 SNCONST,SNEXP,LNCONST,LNEXP
      REAL*8 CRITDIAM,MAXWALLGRADIENT
      real*8 zmin,zmax
      LOGICAL DEPOSITNOISE,MICRONOISE,NOISECALL,DIFFUSECALL
      LOGICAL USEFOLD, SOFTCRATER,isxperiodic,isyperiodic,SKIPCRATER
      LOGICAL FEATHER,USEMAXSLOPE
      character rprefix*6,rnum1*1,rsuffix*4,rfilename*25,dsuffix*4
      character esuffix*4,eprefix*6
      character*25 dfilename,efilename
      character dprefix*6,rnum2*1
      character*4 SURFER
      integer ifile1,ifile2,ifile3
      real*8 :: el(immx,jmmx)
      real*8 :: eslope(immx,jmmx)
      real*8 :: ebase(immx,jmmx)
      real*8 ::WEIGHTS(2,2,4)
      real*8 :: SIZES(1000),XLOCS(1000),YLOCS(1000)
      integer :: III(1000),JJJ(1000)
       real*8 :: DCATS(10)
       integer :: OCATS(10),RCATS(10)
      end module crater_vars
! *******************************************************************************      
      program makecrater
      use crater_vars
      implicit none
      integer i,j,k,iseed,ixperiod,iyperiod,mxx,myy
      integer idofeather, ielscale
	real*8 sum,elrange,maxel,minel
	real*8 aax,bbx,aay,bby
      INTEGER RNSEED, NRANDOM, IERROR
      INTEGER, DIMENSION(:), ALLOCATABLE :: RANDSEED
	maxel=-1.0e+25
	minel=-maxel
	depositnoise=.true.
      usemaxslope=.true.
	MAXWALLGRADIENT=0.7
      RSUFFIX='.raw'
      RPREFIX='cshade'
      dsuffix='.dat'
      dprefix='crater'
	esuffix='.dat'
	eprefix='cebase'
      IFILE1=49
      IFILE2=48
	IFILE3=47
          WEIGHTS(1,1,1)=4.0/4.0
          WEIGHTS(1,1,2)=0.0/4.0
          WEIGHTS(1,1,3)=0.0/4.0
          WEIGHTS(1,1,4)=0.0/4.0
          WEIGHTS(2,1,1)=2.0/4.0
          WEIGHTS(2,1,2)=2.0/4.0
          WEIGHTS(2,1,3)=0.0/4.0
          WEIGHTS(2,1,4)=0.0/4.0
          WEIGHTS(1,2,1)=2.0/4.0
          WEIGHTS(1,2,2)=0.0/4.0
          WEIGHTS(1,2,3)=2.0/4.0
          WEIGHTS(1,2,4)=0.0/4.0
          WEIGHTS(2,2,1)=1.0/4.0
          WEIGHTS(2,2,2)=1.0/4.0
          WEIGHTS(2,2,3)=1.0/4.0
          WEIGHTS(2,2,4)=1.0/4.0
          DO 100 I=1, 2
          DO 100 J= 1, 2
              SUM = 0.0
              DO 110 K= 1,4
110              SUM = SUM+WEIGHTS(I,J,K)
              IF (SUM.NE.1.0) THEN 
                 WRITE(*,120) I,J
120              FORMAT(' BAD WEIGHTS AT I=',I5,' J=',I5)
                 STOP
              ENDIF
100       CONTINUE
      open(20,file='makecrater_XY.prm')
      read(20,*) mx,my, dxx
	read(20,*) ixperiod,iyperiod, idofeather
      read(20,*) ncraters, rnseed
      read(20,*) inputtype,outputtype
      read(20,*) h1mult,h1exp,h2mult,h2exp,critdiam
      read(20,*) sh1mult,sh1exp,sh2mult,sh2exp
      read(20,*) snconst,snexp,lnconst,lnexp
      read(20,*) alpha,beta
      read(20,*) diamcut,mindiam,maxdiam
      read(20,*) depositsd,noisesd
      read(20,*) elevinherit
      CALL RANDOM_SEED(SIZE=NRANDOM)
      ALLOCATE(RANDSEED(NRANDOM))
      RANDSEED=RNSEED
      CALL RANDOM_SEED(PUT=RANDSEED)
      DEALLOCATE (RANDSEED)
      do k=1,ncraters
         read(20,*) xlocs(k),ylocs(k), sizes(k)
         xlocs(k)=xlocs(k)*dxx
         ylocs(k)=ylocs(k)*dxx
         sizes(k)=sizes(k)
      enddo
      if (idofeather.gt.0) then
         feather=.true.
      else
         feather=.false.
      endif
	if (ixperiod.gt.0) then
		isxperiodic=.true.
	else
		isxperiodic=.false.
	endif
	if (iyperiod.gt.0) then
		isyperiodic=.true.
	else
		isyperiodic=.false.
	endif
	write(*,3456) ixperiod,iyperiod
3456  format(' ix=',i5,' iy=',i5)
      CCON=1.0/(1.0/MAXDIAM**ALPHA-1.0/MINDIAM**ALPHA)
	BCON=-CCON/MINDIAM**ALPHA
	ALINV=1.0/ALPHA
      DIAMETER=MAXDIAM
      RADIUS=DIAMETER/2.0
      H1=H1MULT*DIAMETER**H1EXP
      H2=H2MULT*DIAMETER**H2EXP
      M1=LNCONST*DIAMETER**LNEXP
      M2=2.0-(H2/((H2-H1)/2.0+H1/(M1+2)))
      MAXRANGE=DMIN1(mx*dxx,RADIUS*(1.0/0.01)**(1.0/(M2-1.0)))
! **********************************************************************
!
!  ******* THE TOTAL PLAYING FIELD SIZE IS SCALED SO THAT ALL SIGNIFICANT
!          DEPOSTION FROM A 50 KM CRATER OFF THE TARGET FIELD WILL BE
!          ACCOUNTED FOR
!
! **********************************************************************
	CALL FINDRANGE()
      if (inputtype.eq.0) then
         do i=1,mx
            do j=1,my
               el(i,j)=0.0
            enddo
         enddo
         xmin=dxx
         xmax=mx*dxx
         ymin=dxx
         ymax=my*dxx
      else
       if (inputtype.eq.1) then
         open(21,file='incrater.dat')
         read(21,*) mxx,myy
         if ((mxx.ne.mx).or.(myy.ne.my)) then
            write(*,703) mx,mxx,my,myy
            stop
         endif
         do i=1,mx
         do j=1,my
            read(21,*) el(i,j)
         enddo
         enddo
        xmin=dxx
         xmax=mx*dxx
         ymin=dxx
         ymax=my*dxx
       else
         open(21,file='incrater.dat')
         read(21,703) surfer
704   format(a4)
         read(21,*) mxx,myy
         if ((mxx.ne.mx).or.(myy.ne.my)) then
            write(*,703) mx,mxx,my,myy
703   format('incompatable input dimensions, mx=',i5,' mxx=',i5, &
      ' my=',i5,' myy=',i5)
            stop
         endif
         read(21,*) xmin,xmax
         read(21,*) ymin,ymax
         read(21,*) zmin,zmax
         do j=1,myy
            read(21,*) (el(i,j),i=1,mxx)
         enddo
         endif
         endif
            do j=1,my
            do i=1,mx
	         if (el(i,j).gt.maxel) maxel=el(i,j)
	         if (el(i,j).lt.minel) minel=el(i,j)
            enddo
            enddo
	       do i=1,mx
            do j=1,my
	            ebase(i,j)=el(i,j)
	         enddo
	      enddo
	write(*,201) minel, maxel
201   format(' minel=',g12.5,' maxel=',g12.5)
      aax=(mx-1)/(xmax-xmin)
      bbx=1.0-aax*xmin
      aay=(my-1)/(ymax-ymin)
      bby=1.0-aay*ymin
      do i=1,ncraters
         iii(i)=nint(xlocs(i)*aax+bbx)
         jjj(i)=nint(ylocs(i)*aay+bby)
         write(*,4667) i,iii(i),jjj(i)
         4667 format(3i6)
	   SKIPCRATER=.FALSE.
         call cratering(i)
      enddo
      call writeout()
      end
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine writeout()
      use crater_vars
      implicit none
      integer i,j
	real elbasemax,elcomp
	    RNUM1=CHAR(IFILE1)
	    RNUM2=CHAR(IFILE2)
          rFILENAME=RPREFIX//RNUM2//RNUM1//RSUFFIX
          dFILENAME=dPREFIX//RNUM2//RNUM1//dSUFFIX
          eFILENAME=ePREFIX//RNUM2//RNUM1//eSUFFIX
          IFILE1=IFILE1+1
          IF (IFILE1.GT.57) THEN
              IFILE1=48
              IFILE2=IFILE2+1
          ENDIF
      if (outputtype.eq.0) then
      open(44,file='newout.dat')
      write(44,200) mx,my
200   format(i5,' ',i5)
      do i=1,mx
      do j=1,my
      write(44,201) el(i,j)
201   format(g12.5)      
      enddo
      enddo
      else      
      OPEN(44,NAME='newout.grd')
      write(44,109) surfer
109   format(a4)
      write(44,110) mx,my
110   format(2i6)
      write(44,111) xmin,xmax
      write(44,111) ymin,ymax
111   format (g12.5,' ',g12.5)
      zmin=1.0e+25
      zmax=-1.0e+25
      do j=1,my
         do i=1,mx
            if (el(i,j).gt.zmax) zmax=el(i,j)
            if (el(i,j).lt.zmin) zmin=el(i,j)
         enddo
      enddo
      write(44,111) zmin,zmax
      do j=1,my
         write(44,112) (el(i,j),i=1,mx)
      enddo
112   format(1024(g12.5,' '))
      endif
      close (44)
      open(44,name=rfilename)
      call shade()
      close(44)
100   format(g15.7)
      end 
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SUBROUTINE CRATERING(kk)
      use crater_vars
      implicit none
	integer kk
      INTEGER*4 I,J,K
      COUNT2=0
      COUNT10=0

! ******** GENERATE A RANDOM CRATER SIZE FROM THE ASSUMED POPULATION
!          DISTRIBUTION
!
! **********************************************************************
          CALL SETSIZE(kk)
! **********************************************************************
!
! ******** WHERE IN THE TOTAL PLAYING FIELD DID IT HIT?
!
! **********************************************************************
          CALL IMPACTSITE(kk)
! **********************************************************************
!
! ******** DETERMINE THE AVERAGE ELEVATION OF THE IMPACTOR FOOTPRINT
!
! **********************************************************************
          IF (.NOT.SKIPCRATER) THEN
          CALL FINDELEVBASE()
! **********************************************************************
!
! ******** DO THE EXCAVATION AND DEPOSITION
!
! **********************************************************************
              CALL BLAST()
! **********************************************************************
          ENDIF
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
      SUBROUTINE SETSIZE(i)
!      INCLUDE 'erode.ins'
      use crater_vars
      implicit none
	integer i
      REAL*4 TEMP
	REAL*8 TEMP1,DIAMRATIO
	
! **********************************************************************
!
! ******* DETERMINE A RANDOM IMPACTOR DIAMETER FROM A NEGATIVE
!         POWER FUNCTION CUMULATIVE DIAMETER SIZE.  ALSO DETERMINE
!         PARAMETERS GOVERNING EXCAVATION AND DEPOSITION SHAPE 
!         FUNCTIONS AND THE MAXIMUM RANGE OF THE IMPACTOR FOOTPRINT
!
! **********************************************************************
110   CONTINUE
      DIAMETER=sizes(i)
      WRITE(*,7000) i,DIAMETER
7000  FORMAT(i7,' D=',G12.5)      
      RADIUS=DIAMETER/2.0
      DIAMRATIO=DIAMETER/CRITDIAM
      IF (DIAMRATIO.GE.1.0) THEN
         H1=H1MULT*DIAMETER**H1EXP
         H2=H2MULT*DIAMETER**H2EXP
         M1=LNCONST*DIAMETER**LNEXP
      ELSE
         H1=SH1MULT*DIAMETER**SH1EXP
         H2=SH2MULT*DIAMETER**SH2EXP
         M1=SNCONST*DIAMETER**SNEXP
      ENDIF
      M2=2.0-(H2/((H2-H1)/2.0+H1/(M1+2)))
      MAXRANGE=DMIN1(mx*dxx,RADIUS*(1.0/0.01)**(1.0/(M2-1.0)))
	 WRITE (*,100) maxrange, H1, H2, M1, M2
100   FORMAT(' maxrange=',g12.5,' H1=',G12.5,' H2=',G12.5,&
      ' M1=',G12.5,' M2=',G12.5)
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
      SUBROUTINE FINDRANGE()
      use crater_vars
      implicit none
      IF (ISXPERIODIC) THEN
          XMIN=0.0
          XMAX=MX*DXX
      ELSE
          XMIN=-MAXRANGE
          XMAX=MX*DXX+MAXRANGE
      ENDIF
      IF (ISYPERIODIC) THEN
          YMIN=0.0
          YMAX=MY*DXX
      ELSE
          YMIN=-MAXRANGE
          YMAX=MY*DXX+MAXRANGE
      ENDIF
      write(*,100) xmin,xmax,ymin,ymax
      100 format(' xmin=',g12.5,' xmax=',g12.5,' ymin=',g12.5,' ymax=',g12.5)
   
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
      SUBROUTINE IMPACTSITE(KK)
      use crater_vars
      implicit none
      integer kk
      REAL*4 XTEMP,YTEMP
      REAL*8 RAND
	INTEGER ICNTR,JCNTR
      ICNTR=III(KK)
      JCNTR=JJJ(KK)
      XCENTER=xlocs(KK)
      YCENTER=ylocs(KK)
      WRITE(*,7000) ICNTR,JCNTR
7000  FORMAT(' I=',I5,' J=',I5)      
      IMIN=MAX0(1,INT(1+(XCENTER-MAXRANGE)/DXX))
      IMAX=MIN0(MX,INT(1+(XCENTER+MAXRANGE)/DXX))
      JMIN=MAX0(1,INT(1+(YCENTER-MAXRANGE)/DXX))
      JMAX=MIN0(MY,INT(1+(YCENTER+MAXRANGE)/DXX))
! **********************************************************************
!
! ***** IF PERIODIC LEFT AND RIGHT BOUNDARIES ARE USED, IMINR AND IMAXR
!       ARE THE LARGER DOMAIN THAT ALLOW BOUNDARY OVERLAP
!
! **********************************************************************
      IF (ISXPERIODIC) THEN
          IF (USEFOLD) THEN
              IMINR=MAX0(-MX+1,INT(1+(XCENTER-MAXRANGE)/DXX))
              IMAXR=MIN0(2*MX,INT(1+(XCENTER+MAXRANGE)/DXX))
          ELSE
              IMINR=MAX0(ICNTR-MX/2+1,INT(1+(XCENTER-MAXRANGE)/DXX))
              IMAXR=MIN0(ICNTR+MX/2,INT(1+(XCENTER+MAXRANGE)/DXX))
          ENDIF
      ELSE
          IMINR=IMIN
          IMAXR=IMAX
      ENDIF
      IF (ISYPERIODIC) THEN
          IF (USEFOLD) THEN
              JMINR=MAX0(-MY+1,INT(1+(YCENTER-MAXRANGE)/DXX))
              JMAXR=MIN0(2*MY,INT(1+(YCENTER+MAXRANGE)/DXX))
          ELSE
              JMINR=MAX0(JCNTR-MY/2+1,INT(1+(YCENTER-MAXRANGE)/DXX))
              JMAXR=MIN0(JCNTR+MY/2,INT(1+(YCENTER+MAXRANGE)/DXX))
          ENDIF
      ELSE
          JMINR=JMIN
          JMAXR=JMAX
      ENDIF
      IF     &
             ((IMINR.EQ.-128).OR.(IMAXR.EQ.256).OR.(JMINR.EQ.-128).OR. &
             (JMAXR.EQ.256)) THEN
      ENDIF
	IF (.NOT.ISYPERIODIC) THEN
          if (feather) then
	    IF (YCENTER.LT.(1.2*RADIUS)) SKIPCRATER=.TRUE.
	    IF (YCENTER.GT.(MY*DXX)) SKIPCRATER=.TRUE.
	    IF (ABS((MY*DXX)-YCENTER).LT.(2.0*RADIUS)) SKIPCRATER=.TRUE.
          endif
	ENDIF
	write(*,5664) iminr,imaxr,jminr,jmaxr
	5664 format('iminr=',i5,' imaxr=',i5, ' jminr=',i5, ' jmaxr=',i5)
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
      SUBROUTINE BLAST()
      use crater_vars
      implicit none
      INTEGER I,J,ITEMP,JTEMP
      REAL*8 XCOMP,YCOMP,DCOMP,ECHANGE,TEMP1,TEMP2,DEPOSITTHICK
      REAL*8 EUSE,TOTALVOL,BIASADD,TOTPOINTS
	REAL*8 NETCHANGE,NETPOINTS,SDRAT,DELELEV,lognormal
      LOGICAL*1 NOTDONE(IMMX,JMMX),NEWSEDBASE(IMMX,JMMX)
! **********************************************************************
!
!  ******  THIS SUBROUTINE DOES THE ACTUAL WORK OF EXCAVATING AND
!          DEPOSITING.  SMALL CRATERS OFF OF THE TARGET AREA ARE
!          BYPASSED
!
! **********************************************************************
      IF ((IMAX.GE.IMIN).AND.(JMAX.GE.JMIN)) THEN
      TOTALVOL=0.0
      TOTPOINTS=0.0
	NETCHANGE=0.0
	NETPOINTS=0.0
	WRITE(*,200) IMINR,JMINR,IMAXR,JMAXR
200   FORMAT(' IMIN=',I5,' JMIN=',I5,' IMAX=',I5,' JMAX=',I5)
! **********************************************************************
!
!  ****** IF WERE HERE WE MODEL THE IMPACT.  UPDATE COUNTERS.
!
! **********************************************************************
      ITOTHITS=ITOTHITS+1
      IF (DIAMETER.GT.2.0) COUNT2=COUNT2+1
      IF (DIAMETER.GT.10.0) COUNT10=COUNT10+1
	DIFFUSECALL=.TRUE.
	NOISECALL=.TRUE.
      DO 2100 ITEMP=IMINR,IMAXR
          DO 2100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              ESLOPE(I,J)=0.0
              NOTDONE(I,J)=.TRUE.
              NEWSEDBASE(I,J)=.FALSE.
2100  CONTINUE
! **********************************************************************
!
! ****** CYCLE ACROSS THE FOOTPRINT AREA ON THE TARGET MATRIX
!
! **********************************************************************
      DO 100 ITEMP=IMINR,IMAXR
          DO 100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              XCOMP=(ITEMP-1)*DXX
              YCOMP=(JTEMP-1)*DXX
              DCOMP=DSQRT((XCOMP-XCENTER)**2+(YCOMP-YCENTER)**2)
! **********************************************************************
!
! *****   DCOMP IS THE RADIAL  DISTANCE OF THE PRESENT LOCATION ON
!         THE FOOTPRINT FROM THE CRATER CENTER.  WE MODEL THE INTERIOR
!         AND EXTERIOR OF THE CRATER SEPARATELY
!
! **********************************************************************
              IF (DCOMP.LE.RADIUS) THEN
! **********************************************************************
!
! *****   MODEL THE CRATER INTERIOR
!
! **********************************************************************
				DEPOSITTHICK=H1*(DCOMP/RADIUS)**M1
! **********************************************************************
!
! *****   RANDOM VARIABILITY OF CRATER ELEVATION IS PRESENTLY ALLOWED
!         ONLY IN AREAS OF NET DEPOSITION.  PERHAPS IT ALSO OUGHT TO
!         BE ALLOWED ON THE LOWER CRATER RIM
!
! **********************************************************************
                  IF (DEPOSITNOISE) THEN
                       DEPOSITTHICK=DEPOSITTHICK  &
                             *LOGNORMAL(DEPOSITSD)
                  ENDIF
				DEPOSITTHICK=DEPOSITTHICK+(H2-H1)
! **********************************************************************
!
! *****   THE AMOUNT OF INHERITANCE OF THE ORIGINAL TOPOGRAPHY INCREASES 
!         FROM ZERO AT THE CRATER CENTER (WHERE THE AVERAGE ELEVATION OF
!         THE FOOTPRINT IS USED) TO ELEVINHERIT AT THE RIM
!
! **********************************************************************
                  EUSE=ELEVINHERIT*(DCOMP/RADIUS)**2
                  ESLOPE(I,J)=ESLOPE(I,J)+ &
                         (1.0-EUSE)*(ELEVBASE-EL(I,J))+ &
                         DEPOSITTHICK
                  NEWSEDBASE(I,J)=.TRUE.
              ELSE
! **********************************************************************
!
! ******  MODEL THE CRATER EXTERIOR.  THE FRACTIONAL INHERITANCE OF THE
!         ORIGINAL TOPOGRAPHY GOES FROM ELEVINHERIT AT THE RIM TO 100%
!         AT THE FAR MARGINS OF DEPOSITION
!
! **********************************************************************
                  TEMP1=(RADIUS/DCOMP)**M2
                  TEMP2=DMIN1((1.0-ELEVINHERIT),TEMP1)
                  DEPOSITTHICK=H2*TEMP1
! **********************************************************************
!
! ******  DETERMINE THE RANDOM VARIABILITY OF DEPOSITIONAL AMOUNT.
!
! **********************************************************************
                  IF (DEPOSITNOISE) THEN
                       DEPOSITTHICK=DEPOSITTHICK*LOGNORMAL(DEPOSITSD)
                  ENDIF
                  ESLOPE(I,J)=ESLOPE(I,J)+(ELEVBASE-EL(I,J))*TEMP2 &
                         +DEPOSITTHICK
                  IF (ABS(ESLOPE(I,J)).GT.0.001) THEN
                     NEWSEDBASE(I,J)=.TRUE.
                  ENDIF
              ENDIF
100       CONTINUE
      DO 3100 ITEMP=IMINR,IMAXR
          DO 3100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              IF (NOTDONE(I,J)) THEN
                  TOTALVOL=TOTALVOL+ESLOPE(I,J)
                  TOTPOINTS=TOTPOINTS+1.0
                  NOTDONE(I,J)=.FALSE.
              ENDIF
3100      CONTINUE
      BIASADD=-TOTALVOL/TOTPOINTS
      DO 4100 ITEMP=IMINR,IMAXR
          DO 4100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              NOTDONE(I,J)=.TRUE.
4100  CONTINUE
       DO 1100 ITEMP=IMINR,IMAXR
          DO 1100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              XCOMP=(ITEMP-1)*DXX
              YCOMP=(JTEMP-1)*DXX
              DCOMP=DSQRT((XCOMP-XCENTER)**2+(YCOMP-YCENTER)**2)
              IF (NOTDONE(I,J)) THEN
                  DELELEV=+ESLOPE(I,J)+BIASADD
                  EL(I,J)=EL(I,J)+DELELEV
                  IF (EL(I,J).LT.EBASE(I,J)) EBASE(I,J)=EL(I,J)
                  NOTDONE(I,J)=.FALSE.
              ENDIF
1100      CONTINUE
      ELSE
          WRITE(*,130)
130   FORMAT(' MISS')
      ENDIF
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SUBROUTINE FINDELEVBASE()
      use crater_vars
      implicit none
      REAL*8 TEMP,WEIGHT,XCOMP,YCOMP,DCOMP
      INTEGER I,J,ITEMP,JTEMP
! **********************************************************************
!
! ***** FINDS THE AVERAGE ELEVATION OF THE FOOTPRINT. THE ONLY TRICK
!       IS THAT THE LOCATIONS LYING WITHIN THE NEW CRATER INTERIOR ARE
!       GIVEN GREATEST WEIGHTING AND THAT POINTS OUTSIDE THE CRATER RIM
!       ARE GIVEN A WEIGHTING IN DETERMINING THE AVERAGE ELEVATION IN
!       PROPORTION TO THE AMOUNT OF DEPOSITION THAT WILL OCCUR
!
! **********************************************************************
      ELEVBASE=0.0
      WEIGHT=0.0
      IF ((IMAX.GE.IMIN).AND.(JMAX.GE.JMIN)) THEN
      DO 100 ITEMP=IMINR,IMAXR
          DO 100 JTEMP=JMINR,JMAXR
              I=ITEMP
              J=JTEMP
! **********************************************************************
!
! ******   IF THE LATERAL BOUNDARIES ARE PERIODIC, THEN ALLOW THE 
!          BOUNDARY OVERLAP
!
! **********************************************************************
              IF (ISXPERIODIC) THEN
                  IF (ITEMP.LT.1) I=ITEMP+MX
                  IF (ITEMP.GT.MX) I=ITEMP-MX
              ENDIF
              IF (ISYPERIODIC) THEN
                  IF (JTEMP.LT.1) J=JTEMP+MY
                  IF (JTEMP.GT.MY) J=JTEMP-MY
              ENDIF
              XCOMP=(I-1)*DXX
              YCOMP=(J-1)*DXX
              DCOMP=DSQRT((XCOMP-XCENTER)**2+(YCOMP-YCENTER)**2)
              IF (DCOMP.LE.RADIUS) THEN
                  ELEVBASE=ELEVBASE+EL(I,J)
                  WEIGHT=WEIGHT+1.0
              ELSE
                  TEMP=(RADIUS/DCOMP)**M2
                  ELEVBASE=ELEVBASE+EL(I,J)*TEMP
                  WEIGHT=WEIGHT+TEMP
              ENDIF
100       CONTINUE
      ELEVBASE=ELEVBASE/WEIGHT
      ENDIF
	RETURN
	END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      REAL*8 FUNCTION NORMAL()
      use ifport
      IMPLICIT NONE
! ********************************************************************
!  GENERATES A NORMALLY DISRIBUTED RANDOM DEVIATE
! ********************************************************************
      REAL*8 V1, V2, SS
      REAL*4 TEMP1,TEMP2
      REAL*8 TEMP3
   10 CONTINUE
      CALL RANDOM_NUMBER(TEMP1)
      CALL RANDOM_NUMBER(TEMP2)
      V1 = 2.0*TEMP1-1.0
      V2 = 2.0*TEMP2-1.0
      SS = V1*V1 + V2*V2
      IF (SS.GE.1.0) GOTO 10 
      TEMP3=-2.0*DLOG(SS)/SS
      IF (TEMP3.GT.0.0) THEN
         SS = DSQRT(TEMP3)
      ELSE
         WRITE(*,150)
150      FORMAT(' NEGATIVE ARGUMENT TO RANDOM DEVIATE')
         STOP
      ENDIF
      NORMAL = V1*SS 	   
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      REAL*8 FUNCTION LOGNORMAL(STDEV)
      IMPLICIT NONE
! ********************************************************************
!   GENERATES A LOGNORMALLY DISTRIBUTED RANDOM DEVIATE  
! ********************************************************************
      REAL*8 STDEV, Y,NORMAL,ETERM
      Y = NORMAL()
      LOGNORMAL = DEXP((1.0-0.5*STDEV)*Y*STDEV)
      RETURN
      END							       
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
! %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      REAL*8 FUNCTION EXPONDIST()
      use ifport
      IMPLICIT NONE
! ********************************************************************
!   GENERATES A EXPONENTIALLY DISTRIBUTED RANDOM DEVIATE    
! ********************************************************************C
      REAL*8 STDEV
      REAL*4 Y
100   CALL RANDOM_NUMBER(Y)
      IF (Y.EQ.0.0) GOTO 100
      STDEV=Y
      EXPONDIST=-DLOG(STDEV)
      RETURN
      END
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SUBROUTINE SHADE()
      use crater_vars
      implicit none
      REAL*8 HALFPI,PI,RADIAN,NOMANGLE,dxxx
      REAL*8 YDIV,SLX,SLY,SLOPE,SLMAX,SLSUN,ANGLE,SLOPEANGLE,NEWVALUE
      INTEGER I,J,IW,IE,JS,JN, SELECT,SLOPENUMB,IMX,JMX
      REAL*8	 NOMSLMAX,RRRR,RANGE,SLOPEAVG,XDIV
      INTEGER II,JJ,IISTART,IIEND,JJSTART,JJEND
      REAL*8 XVAL1,XVAL2,XVAL3,XVAL4,XAVG,minval,maxval
      BYTE BVAL
	INTEGER ITEMP,xreflect,yreflect
	CHARACTER ACHAR        
	IMX=mx
	JMX=my
!
! ******  MAKES A SHADED RELIEF RAW IMAGE OF THE SIMULATED TERRAIN AND
!         WRITES IT OUT TO A FILE
!
	HALFPI =1.5708
      PI=3.141593
      RADIAN=0.01745329
      NOMANGLE=25.0
	if (isxperiodic) then
		xreflect=1
	else
		xreflect=0
	endif
	if (isyperiodic) then
		yreflect=1
	else
		yreflect=0
	endif
          SLMAX=-1.0E+25
          SLOPEAVG=0.0
          SLOPENUMB= 0
          DO 101 I = 2,IMX-1 
          DO 101 J = 2,JMX-1 
             IW=I-1
             IE=I+1
             JS=J+1
             JN=J-1
             SLX = ( el(IE,J)- el(IW,J))/2.0
             SLY = ( el(I,JN)- el(I,JS))/2.0
             SLOPE =SQRT(SLX**2+SLY**2)
             IF (SLOPE.GT.SLMAX) SLMAX = SLOPE
             SLOPENUMB = SLOPENUMB+1
             SLOPEAVG = SLOPEAVG+SLOPE
101        CONTINUE
      	 NOMSLMAX = SIN(HALFPI-NOMANGLE*RADIAN)/ &
             COS(HALFPI-NOMANGLE*RADIAN)
      	 DXXx = SLMAX/NOMSLMAX
      	 SLMAX = NOMSLMAX
          SLOPEAVG = SLOPEAVG/(SLOPENUMB*DXXx)
          SLSUN=HALFPI-DATAN(SLMAX)
          DO 102 I = 1,IMX 
          DO 102 J = 1,JMX 
             IW=I-1
             IE=I+1
             JS=J+1
             JN=J-1
             YDIV=2.0*DXXx
             XDIV=2.0*DXXx										             
		   IF (JS.GT.JMX) THEN
               YDIV=1.0*DXXx
               JS=JMX
             ENDIF
             IF (JN.LT.1) THEN
               YDIV=1.0*DXXx
               JN=1
             ENDIF
             IF (IW.LT.1) THEN
                XDIV=1.0*DXXx
                IW=1
             ENDIF
             IF (IE.GT.IMX) THEN
                XDIV=1.0*DXXx
                IE=IMX
             ENDIF
             SLX = ( el(IE,J)- el(IW,J))/XDIV
             SLY = ( el(I,JS)- el(I,JN))/YDIV
             SLOPE =dSQRT(SLX**2+SLY**2)
             SLOPEANGLE= DATAN(SLOPE)
             IF ((SLY.EQ.0.0).OR. (SLX.EQ.0.0)) THEN
               IF (SLY.EQ.0.0) THEN
                 IF (SLX.GT.0.0) THEN
                     ANGLE =  HALFPI
                 ELSE
                     ANGLE = -HALFPI
                 ENDIF
               ELSE
                   IF (SLY.GT.0.0) THEN
                     ANGLE = 0.0
                   ELSE
                     ANGLE = PI
                   ENDIF
               ENDIF
             ELSE
                 ANGLE = DATAN ((SLX) / (SLY))
                 IF (((SLY) .LT. 0.0).AND.((SLX) .LT. 0.0)) THEN
                   ANGLE = ANGLE + PI
                 ELSE
                   IF ((SLY) .LT. 0.0) THEN
                      ANGLE = ANGLE + PI
                   ENDIF
                 ENDIF
              ENDIF
               ANGLE = ANGLE-HALFPI
               NEWVALUE =               &
                  (COS(SLSUN)*COS(SLOPEANGLE)+SIN(SLSUN) &
                         *SIN(SLOPEANGLE)* &
                      COS(ANGLE))
               IF (NEWVALUE.LT.0.0) NEWVALUE = 0.0
               eslope(I,J) = NEWVALUE
102       CONTINUE
         MAXVAL = -1.0E+25
         MINVAL = -MAXVAL
         DO 100 I = 1,IMX 
         DO 100 J = 1,JMX 
           RRRR = eslope(I,J)
           IF (RRRR.LT.MINVAL) MINVAL = RRRR
           IF (RRRR.GT. MAXVAL) MAXVAL = RRRR
100      CONTINUE
      RANGE=MAXVAL-MINVAL
      IF (YREFLECT.GT.0) THEN
          JJSTART=JMX-JMX/4
          JJEND=JMX
      DO 1120 J=JJSTART,JJEND
          DO 1121 JJ=1,2
             IF (XREFLECT.GT.0) THEN
                IISTART=IMX-IMX/4
                IIEND=IMX
             DO 1123 I=IISTART,IIEND
                 XVAL1=eslope(I,J)
                 IF (I.EQ.IIEND) THEN
                  XVAL2=eslope(1,J)
                  IF (J.EQ.JJEND) THEN
                      XVAL4=eslope(1,1)
                  ELSE
                      XVAL4=eslope(1,J+1)
                  ENDIF
                 ELSE
                  XVAL2=eslope(I+1,J)
                  IF (J.EQ.JJEND) THEN
                      XVAL4=eslope(I+1,1)
                  ELSE
                      XVAL4=eslope(I+1,J+1)
                  ENDIF
                 ENDIF
                 IF (J.EQ.JJEND) THEN
                  XVAL3=eslope(I,1)
                 ELSE
                  XVAL3=eslope(I,J+1)
                 ENDIF
                 DO 1124 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+   &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+  &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
1124              CONTINUE
1123          CONTINUE
             ENDIF
             DO 1125 I=1,IMX-1
                 XVAL1=eslope(I,J)
                  XVAL2=eslope(I+1,J)
                  IF (J.EQ.JJEND) THEN
                      XVAL4=eslope(I+1,1)
                      XVAL3=eslope(I,1)
                  ELSE
                      XVAL4=eslope(I+1,J+1)
                      XVAL3=eslope(I,J+1)
                  ENDIF
                 DO 1126 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+   &
                         XVAL2*WEIGHTS(II,JJ,2)+  &
                         XVAL3*WEIGHTS(II,JJ,3)+  &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
1126              CONTINUE
1125          CONTINUE
          IF (XREFLECT.GT.0) THEN
              IISTART=0
              IIEND=IMX/4
             DO 1127 I=IISTART,IIEND
                 XVAL2=eslope(I+1,J)
                 IF (I.EQ.IISTART) THEN
                  XVAL1=eslope(IMX,J)
                  IF (J.EQ.JJEND) THEN
                      XVAL3=eslope(IMX,1)
                  ELSE
                      XVAL3=eslope(IMX,J+1)
                  ENDIF
                 ELSE
                  XVAL1=eslope(I+1,J)
                  IF (J.EQ.JJEND) THEN
                      XVAL3=eslope(I,1)
                  ELSE
                      XVAL3=eslope(I,J+1)
                  ENDIF
                 ENDIF
                 IF (J.EQ.JJEND) THEN
                  XVAL4=eslope(I+1,1)
                 ELSE
                  XVAL4=eslope(I+1,J+1)
                 ENDIF
                 DO 1128 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+  &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
1128              CONTINUE
1127          CONTINUE
          ENDIF
1121       CONTINUE
1120   CONTINUE
      ENDIF
      DO 120 J=1,JMX-1
          DO 121 JJ=1,2
             IF (XREFLECT.GT.0) THEN
                IISTART=IMX-IMX/4
                IIEND=IMX
             DO 123 I=IISTART,IIEND
                 XVAL1=eslope(I,J)
                 IF (I.EQ.IIEND) THEN
                  XVAL2=eslope(1,J)
                  XVAL4=eslope(1,J+1)
                 ELSE
                  XVAL2=eslope(I+1,J)
                  XVAL4=eslope(I+1,J+1)
                 ENDIF
                 XVAL3=eslope(I,J+1)
                 DO 124 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+  &
                         XVAL3*WEIGHTS(II,JJ,3)+  &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
124              CONTINUE
123          CONTINUE
             ENDIF
             DO 125 I=1,IMX-1
                 XVAL1=eslope(I,J)
                  XVAL2=eslope(I+1,J)
                  XVAL4=eslope(I+1,J+1)
                 XVAL3=eslope(I,J+1)
                 DO 126 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+ &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
126              CONTINUE
125          CONTINUE
          IF (XREFLECT.GT.0) THEN
              IISTART=0
              IIEND=IMX/4
             DO 127 I=IISTART,IIEND
                 XVAL2=eslope(I+1,J)
                 IF (I.EQ.IISTART) THEN
                  XVAL1=eslope(IMX,J)
                  XVAL3=eslope(IMX,J+1)
                 ELSE
                  XVAL1=eslope(I+1,J)
                  XVAL3=eslope(I+1,J+1)
                 ENDIF
                 XVAL4=eslope(I+1,J+1)
                 DO 128 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+ &
                         XVAL2*WEIGHTS(II,JJ,2)+  &
                         XVAL3*WEIGHTS(II,JJ,3)+ &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
128              CONTINUE
127          CONTINUE
          ENDIF
121       CONTINUE
120   CONTINUE
      IF (YREFLECT.GT.0) THEN
          JJSTART=0
          JJEND=JMX/4
      DO 2120 J=JJSTART,JJEND
          DO 2121 JJ=1,2
             IF (XREFLECT.GT.0) THEN
                IISTART=IMX-IMX/4
                IIEND=IMX
             DO 2123 I=IISTART,IIEND
                 IF (J.EQ.JJSTART) THEN
                  XVAL1=eslope(I,JMX)
                 ELSE
                  XVAL1=eslope(I,J)
                 ENDIF
                 IF (I.EQ.IIEND) THEN
                  IF (J.EQ.JJSTART) THEN
                      XVAL2=eslope(1,JMX)
                  ELSE
                      XVAL2=eslope(1,J)
                  ENDIF
                  XVAL4=eslope(1,J+1)
                 ELSE
                  IF (J.EQ.JJSTART) THEN
                      XVAL2=eslope(I+1,JMX)
                  ELSE
                      XVAL2=eslope(I+1,J)
                  ENDIF
                  XVAL4=eslope(I+1,J+1)
                 ENDIF
                  XVAL3=eslope(I,J+1)
                 DO 2124 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+ &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
2124              CONTINUE
2123          CONTINUE
             ENDIF
             DO 2125 I=1,IMX-1
                  IF (J.EQ.JJSTART) THEN
                     XVAL1=eslope(I,JMX)
                     XVAL2=eslope(I+1,JMX)
                  ELSE
                     XVAL1=eslope(I,J)
                     XVAL2=eslope(I+1,J)
                  ENDIF
                  XVAL4=eslope(I+1,J+1)
                  XVAL3=eslope(I,J+1)
                 DO 2126 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+ &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
2126              CONTINUE
2125          CONTINUE
          IF (XREFLECT.GT.0) THEN
              IISTART=0
              IIEND=IMX/4
             DO 2127 I=IISTART,IIEND
                 IF (J.EQ.JJSTART) THEN
                  XVAL2=eslope(I+1,JMX)
                 ELSE
                  XVAL2=eslope(I+1,J)
                 ENDIF
                 IF (I.EQ.IISTART) THEN
                  IF (J.EQ.JJSTART) THEN
                      XVAL1=eslope(IMX,JMX)
                  ELSE
                      XVAL1=eslope(IMX,J)
                  ENDIF
                      XVAL3=eslope(IMX,J+1)
                 ELSE
                  IF (J.EQ.JJSTART) THEN
                      XVAL1=eslope(I,JMX)
                  ELSE
                      XVAL1=eslope(I,J)
                  ENDIF
                  XVAL3=eslope(I,J+1)
                 ENDIF
                 XVAL4=eslope(I+1,J+1)
                 DO 2128 II=1,2
                    XAVG=XVAL1*WEIGHTS(II,JJ,1)+  &
                         XVAL2*WEIGHTS(II,JJ,2)+ &
                         XVAL3*WEIGHTS(II,JJ,3)+ &
                         XVAL4*WEIGHTS(II,JJ,4)
                    ITEMP=INT((XAVG-MINVAL)*253.0/RANGE)+1
                    IF (ITEMP.LT.0) ITEMP=0
                    IF (ITEMP.GT.255) ITEMP=255
                    BVAL=ITEMP
                    ACHAR=char(BVAL)
                    WRITE(44,130) ACHAR
2128              CONTINUE
2127          CONTINUE
          ENDIF
2121       CONTINUE
2120   CONTINUE
      ENDIF
130   FORMAT(A1,$)
      RETURN
      END
      
     
